package Extensions;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.io.*;
import android.app.Activity;
import android.content.Intent;
import Actions.CActExtension;
import Application.CRunApp;
import Conditions.CCndExtension;
import Expressions.CValue;
import RunLoop.CCreateObjectInfo;
import Runtime.Log;
import Runtime.MMFRuntime;
import Services.CBinaryFile;
import Services.CServices;
import Frame.CLayer;
import Objects.CExtension;
import Objects.CObject;
import OI.COC;
import OI.COI;
import OI.CObjectCommon;
import Sprites.CRSpr;
import RunLoop.CObjInfo;
import RunLoop.CRun;
import Events.CQualToOiList;
import Frame.CLO;
import Params.PARAM_OBJECT;
import java.lang.Math;
import java.util.Queue;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.ArrayDeque;
import Sprites.CSprite;
public class CRunSLPA extends CRunExtension{
	static final int DEF_BLOCK_SIZE = 4;
	
	int Active_Check;
	int BackDrop_Check;
	int block_size;	
	int area_w, area_h;	
	int max_x, max_y, max_z;
	class FadeAreaList{
		Queue<CObject> lq;
	}
	FadeAreaList a_map[];
	int fade_size;
	int old_block_x, old_block_y;
	HashMap<Integer, ArrayList<Short> > fixed_map;
	Queue<Integer> phin_fixed_list;
	Queue<Integer> phchange_fixed_list;
	public short oinum_tbl[] = null;
	public CSprite cash_spr_lay[] = null;
    private CValue expRet;
    public CRunSLPA () {
	    expRet = new CValue(0);
    }
	@Override 
	public int getNumberOfConditions(){
		return 0;
	}
    @Override
    public boolean createRunObject(CBinaryFile file, CCreateObjectInfo cob, int version) {
    	Active_Check   = file.readInt();
		block_size = DEF_BLOCK_SIZE;
		area_w = ho.hoAdRunHeader.rhApp.gaCxWin / block_size;
		area_h = ho.hoAdRunHeader.rhApp.gaCyWin / block_size;
		max_x = (ho.hoAdRunHeader.rhFrame.leVirtualRect.right / area_w) + 1;
		max_y = (ho.hoAdRunHeader.rhFrame.leVirtualRect.bottom / area_h) + 1;
		max_z = ho.hoAdRunHeader.rhFrame.nLayers;
		fade_size = 0;
		old_block_x = -1 ; old_block_y = -1;
		int sx = max_x * max_y * max_z;
		a_map = new FadeAreaList[sx];
		int y, x , z;
		FadeAreaList tp;
		for (z = 0; z < max_z; z++) {
			for (y = 0; y < max_y; y++) {
				for (x = 0; x < max_x; x++) {
					tp = new FadeAreaList();
					tp.lq = new ArrayDeque<>();
					a_map[ (z*(max_y*max_x))+(y * max_x) + x] = tp;
				}
			}
		}
		fixed_map = new HashMap<Integer, ArrayList<Short> >();
		phin_fixed_list = new ArrayDeque<Integer>();
		phchange_fixed_list = new ArrayDeque<Integer>();
		short nmax = 0;
		CRun rhPtr = ho.hoAdRunHeader;
		for( z = 0 ; z < rhPtr.rhMaxOI ; z++ ){
			if( nmax < rhPtr.rhOiList[z].oilOi )
				nmax = rhPtr.rhOiList[z].oilOi;
		}
		oinum_tbl = new short[ nmax + 1 ];
		for( z = 0 ; z < rhPtr.rhMaxOI ; z++ ){
			oinum_tbl[ rhPtr.rhOiList[z].oilOi ] = (short)z;
		}
		cash_spr_lay = new CSprite[ rhPtr.rhFrame.nLayers ];
		for( x = 0 ; x < rhPtr.rhFrame.nLayers ; x++ ){
			cash_spr_lay[x] = null;
		}
        return false;
    }
    @Override
    public void destroyRunObject(boolean bFast) {
		int y, x ,z;
		FadeAreaList tp;
		for (z = 0; z < max_z; z++) {
			for (y = 0; y < max_y; y++) {
				for (x = 0; x < max_x; x++) {
					PhaseIn_map( x, y, z, bFast);
					tp = a_map[(z*(max_y*max_x))+(y * max_x) + x];
					tp.lq = null;
					a_map[(z*(max_y*max_x))+(y * max_x) + x] = null;
				}
			}
		}
		if (a_map != null) {
			a_map = null;
		}
		fixed_map.clear();
		fixed_map = null;
		phin_fixed_list.clear();
		phin_fixed_list = null;
		phchange_fixed_list.clear();
		phchange_fixed_list = null;
		oinum_tbl = null;
		for( x = 0 ; x < ho.hoAdRunHeader.rhFrame.nLayers ; x++ ){
			cash_spr_lay[x] = null;
		}
		cash_spr_lay = null;
    }
	@Override
    public boolean condition (int num, CCndExtension cnd){
        return false;
    }
    @Override
    public void action (int num, CActExtension act){
        switch (num){
        	case 0: // PhaseOut - Rect
         		break;
         	case 1: // PhaseIn  - Map
         		break;
         	case 2: // PhaseIn  - ALL
         		PhaseIN_ALL();
         		break;
         	case 3: // autoPhaseExecute
         		autoPhaseExecute();
         		break;
         	case 4: // addFixedValueMap
         		PARAM_OBJECT p1 = (PARAM_OBJECT)act.evtParams[0];
         		short val = act.getParamAltValue( ho.hoAdRunHeader,1 );
         		addFixedValueMap( p1 , val );
         		break;
        }
        return;
    }
    @Override
    public CValue expression (int num){
        switch (num){
			case 0: // getPhaseOutCount
				expRet.forceInt( fade_size );
				break;
			case 1: // getPhaseMap_maxX
				expRet.forceInt( max_x );
				break;
			case 2: // getPhaseMap_maxY
				expRet.forceInt( max_y );
				break;
			case 3: // getPhaseMap_AreaW
				expRet.forceInt( area_w );
				break;
			case 4: // getPhaseMap_AreaH
				expRet.forceInt( area_h );
				break;
        }
        return expRet;
    }
    public void PhaseOut_RECT(int left,int top,int right,int bottom ){ // 保留
    }
	public void PhaseIN_map(int map_x , int map_y){ // 保留
	}
	public void PhaseIN_ALL(){
		PhaseIn_ALL();
		ChangePixedValue();
	}
	public void PhaseIn_ALL(){
		int z , y, x;
		for( x = 0 ; x < ho.hoAdRunHeader.rhFrame.nLayers ; x++ ){
			cash_spr_lay[x] = null;
		}
		for (z = 0; z < max_z; z++) {
			for (y = 0; y < max_y; y++) {
				for (x = 0; x < max_x; x++) {
					PhaseIn_map(x, y, z, false);
				}
			}
		}
	}
	public void autoPhaseExecute(){
		if ( Active_Check > 0 ) {
			phaseOutAct();
			phaseInAct();
			ChangePixedValue();
		}
	}
	public void addFixedValueMap( PARAM_OBJECT obj , short val ){
		CRun	rhPtr = ho.hoAdRunHeader;
		ArrayList<Short> itr = fixed_map.get(obj.oi);
		if (itr != null) {// oi
		}else {// oilist none
			itr = new ArrayList<Short>();
			fixed_map.put( Integer.valueOf(obj.oi) , itr );
		}
		if (itr != null) {
			if ( itr.contains( val ) ) {
			}else {
				itr.add( val );
			}
		}
	}
	public void phaseOutAct(){
		int l, t, r, b;
		CRun rhPtr = ho.hoAdRunHeader;
		l = (rhPtr.rh3DisplayX - area_w) ;
		t = (rhPtr.rh3DisplayY - area_h) ;
		r = (rhPtr.rh3DisplayX + ho.hoAdRunHeader.rhApp.gaCxWin + area_w);
		b = (rhPtr.rh3DisplayY + ho.hoAdRunHeader.rhApp.gaCyWin + area_h);
		PhaseOutRect(l,t,r,b);
	}
	public void phaseInAct(){
		CRun	rhPtr = ho.hoAdRunHeader;
		if (old_block_x < 0) {
			old_block_x = rhPtr.rh3DisplayX / area_w;
			old_block_y = rhPtr.rh3DisplayY / area_h;
		}
		int block_x = rhPtr.rh3DisplayX / area_w;
		int block_y = rhPtr.rh3DisplayY / area_h;
		if (block_x != old_block_x || block_y != old_block_y) {
			int l, t, r, b;
			int z, y, x;
			if (fade_size > 0) {
				for( x = 0 ; x < rhPtr.rhFrame.nLayers ; x++ ){
					cash_spr_lay[x] = null;
				}
				for (z = 0; z < max_z; z++) {
					CLayer ml_;
					ml_ = ho.hoAdRunHeader.rhFrame.layers[z];
					l = (int)( (rhPtr.rh3DisplayX - area_w) * ml_.xCoef );
					t = (int)( (rhPtr.rh3DisplayY - area_h) * ml_.yCoef );
					r = (int)( (rhPtr.rh3DisplayX * ml_.xCoef ) + (ho.hoAdRunHeader.rhApp.gaCxWin + area_w) );
					b = (int)( (rhPtr.rh3DisplayY * ml_.yCoef ) + (ho.hoAdRunHeader.rhApp.gaCyWin + area_h) );
					l /= area_w;
					t /= area_h;
					r /= area_w;
					b /= area_h;
					for (y = t; y <= b; y++) {
						for (x = l; x <= r; x++) {
							PhaseIn_map(x,y,z, false);
						}
					}
				}
			}
			old_block_x = block_x;
			old_block_y = block_y;
		}
	}
	public void PhaseIn_map(int x , int y , int z , boolean destroy ){
		if (x < 0 || y < 0 || x >= max_x || y >= max_y)
			return;
		FadeAreaList tp;
		tp = a_map[(z*(max_y*max_x)) + (y * max_x) + x];
		if (tp.lq.size() > 0) {
			int i , lp;
			CRun	rhPtr = ho.hoAdRunHeader;
			CObject obj;
			short ho_num = 0;
			CLayer ml_;
			lp = tp.lq.size();
			for ( i = 0; i < lp; i++) {
				obj = (CObject)tp.lq.poll();
				ho_num = getNullPos(ho_num);
				rhPtr.rhObjectList[ho_num] = obj;
				phin_fixed_list.add(((obj.hoCreationId << 16) | (obj.hoNumber & 0xFFFF)));
				phchange_fixed_list.add(((obj.hoCreationId << 16) | (ho_num & 0xFFFF)));
				obj.hoNumber = ho_num;
				oi_Insert( obj );
				if (obj != null) {
					fade_size--;
					rhPtr.rhNObjects++;
					obj.hoOiList.oilNObjects++;
					ml_ = rhPtr.rhFrame.layers[obj.hoLayer];
					if (ml_.xCoef != 1.0f)
						obj.hoX += (rhPtr.rh3DisplayX - (rhPtr.rh3DisplayX * ml_.xCoef) + ml_.xCoef);
					if (ml_.yCoef != 1.0f)
						obj.hoY += (rhPtr.rh3DisplayY - (rhPtr.rh3DisplayY * ml_.yCoef) + ml_.yCoef);
					if (obj.roc.rcSprite != null) {
						linkLastSprite(obj.roc.rcSprite , obj.hoLayer);
					}
					if (destroy) { 
						obj.kill(true);
					}
				}
			}
		}
	}
	public short getNullPos(short offset){
		short i ;
		CRun	rhPtr = ho.hoAdRunHeader;
		CObject obj;
		for (i = offset; i < rhPtr.rhMaxObjects; i++) {
			if (rhPtr.rhObjectList[i] == null) {
				return i;
			}
		}
		return -1;
	}
	public void PhaseOutRect(int left ,int top , int right ,int bottom){
		CObject obj , rdObj;
		CRun	rhPtr = ho.hoAdRunHeader;
		FadeAreaList tp;
		int x, y,z;
		int obj_x, obj_y;
		CLayer ml_;
		int l, t, r, b;
		int end_obj = rhPtr.rhNObjects;
		int i = 0, next = 0;
		do {
			obj = rhPtr.rhObjectList[next];
			if (obj != null) {
				i++;
				rdObj = obj;
				if ( obj.hoType == COI.OBJ_SPR && (obj.hoOEFlags & CObjectCommon.OEFLAG_SCROLLINGINDEPENDANT) == 0
					&& !((rhPtr.rhDestroyList[obj.hoNumber / 32] & (1 << (obj.hoNumber & 31))) == 1)
					&& rdObj.roc.rcMovementType < Movements.CMoveDef.MVTYPE_EXT
					) {
					z = obj.hoLayer;
					ml_ = ho.hoAdRunHeader.rhFrame.layers[z];
					l = left;
					t = top;
					r = right;
					b = bottom ;
					obj_x = obj.hoX ;
					obj_y = obj.hoY ;
					if (ml_.xCoef != 1.0f)
						obj_x -= (rhPtr.rh3DisplayX - (rhPtr.rh3DisplayX * ml_.xCoef));
					if (ml_.yCoef != 1.0f)
						obj_y -= (rhPtr.rh3DisplayY - (rhPtr.rh3DisplayY * ml_.yCoef));
					if (obj_x >= rhPtr.rhFrame.leVirtualRect.left
						&& obj_y >= rhPtr.rhFrame.leVirtualRect.top
						&& obj_x < rhPtr.rhFrame.leVirtualRect.right
						&& obj_y < rhPtr.rhFrame.leVirtualRect.bottom
						) {
						x = obj_x / area_w ;
						y = obj_y / area_h ;
						if ( (obj.hoX < l || obj.hoX > r || obj.hoY < t || obj.hoY > b ) &&
							(x >= 0 && y >= 0 && x < max_x && y < max_y)
							) {
							if ( (rdObj.hoOEFlags & CObjectCommon.OEFLAG_NEVERSLEEP) == 0 || (rdObj.hoOEFlags & CObjectCommon.OEFLAG_MANUALSLEEP)==0 ){
								obj.hoX = obj_x;
								obj.hoY = obj_y;
								tp = a_map[(z*(max_y*max_x)) + (y * max_x) + x];
								tp.lq.add(obj);
								oi_Delete(obj);
								rhPtr.rhObjectList[next] = null;
								fade_size++;
								if (obj.roc.rcSprite != null) {
									winFreeSprite(obj.roc.rcSprite);
								}
								rhPtr.rhNObjects--;
								rdObj.hoOiList.oilNObjects--;
							}
						}
					}
				}
			}
			next++;
			if (i >= end_obj)break;
		} while (true);
	}
	public void oi_Delete( CObject pHo ) {
		CRun	rhPtr = ho.hoAdRunHeader;
		CObjInfo poil = pHo.hoOiList;
		if (pHo.hoNumPrev >= 0) {
			CObject prev = rhPtr.rhObjectList[pHo.hoNumPrev];
			if (pHo.hoNumNext >= 0) {
				CObject next = rhPtr.rhObjectList[pHo.hoNumNext];
				if (prev != null)
					prev.hoNumNext = pHo.hoNumNext;
				if (next != null)
					next.hoNumPrev = pHo.hoNumPrev;
			}else {
				if (prev != null) {
					prev.hoNumNext = (short)0x8000;
				}
			}
		}else {
			if (pHo.hoNumNext >= 0) {
				CObject next = rhPtr.rhObjectList[pHo.hoNumNext];
				if (next != null) {
					next.hoNumPrev = pHo.hoNumPrev;
					poil.oilObject = next.hoNumber;
				}
			}else {
				poil.oilObject = (short)0x8000;
			}
		}
	}
	public void oi_Insert(CObject pHo) {
		CRun	rhPtr = ho.hoAdRunHeader;
		short oi = pHo.hoOi;
		int num = oinum_tbl[ oi ];
		CObjInfo poil = rhPtr.rhOiList[num];
		if ((poil.oilObject & 0x8000) != 0) {
			poil.oilObject = pHo.hoNumber;
			pHo.hoNumPrev = (short)(num | 0x8000);
			pHo.hoNumNext = (short)0x8000;
		}else{
			CObject pHo2 =rhPtr.rhObjectList[poil.oilObject];
			pHo.hoNumPrev = pHo2.hoNumPrev;
			pHo2.hoNumPrev = pHo.hoNumber;
			pHo.hoNumNext = pHo2.hoNumber;
			poil.oilObject = pHo.hoNumber;
		}
	}
	public void ChangePixedValue() {
		if ( phin_fixed_list.size() <= 0 )return;
		int i = 0 , pos , i2 , i3;
		int next = 0;
		CRun	rhPtr = ho.hoAdRunHeader;
		int end_obj = rhPtr.rhNObjects;
		CObject obj , rdObj ;
		CValue obj_val;
		ArrayList<Short> itr;
		Short itr2[];
		Integer itr3[];
		Integer p_array[];
		do {
			obj = rhPtr.rhObjectList[next];
			if (obj != null ) {
				i++;
				if (obj.hoType == COI.OBJ_SPR) {
					rdObj = obj;
					itr = fixed_map.get(obj.hoOi);
					if (itr != null) {
						itr2 = (Short[])itr.toArray();
						for ( i2 = 0 ; i2 < itr2.length ; i2++ ) {
							obj_val = rdObj.rov.rvValues[ itr2[i2] ];
							pos = 0;
							itr3 = (Integer[])phin_fixed_list.toArray();
							for ( i3 = 0 ; i3 < itr3.length ; i3++ ) {
								if ( obj_val.intValue == itr3[i3] ) {
									p_array = (Integer[])phchange_fixed_list.toArray();
									obj_val.intValue = p_array[pos];
									break;
								}
								pos++;
							}
						}
					}
				}
			}
			next++;
			if (i >= end_obj)break;
		} while (true);
		phin_fixed_list.clear();
		phchange_fixed_list.clear();
	}
	// 再加速
	public void winFreeSprite(CSprite spr) {
		CSprite prev = spr.objPrev;
		CSprite next = spr.objNext;
		if (prev != null) {
			prev.objNext = next;
		}
		if (next != null) {
			next.objPrev = prev;
		}
		// spriteGen
		if( spr == ho.hoAdRunHeader.spriteGen.firstSprite ){
			ho.hoAdRunHeader.spriteGen.firstSprite = next;
		}
	}
	public void linkLastSprite(CSprite spr, int layer) {
		CSprite last_obj = GetFirstSprite_EX(layer, 0);
		if (last_obj == null) {
			return;
		}
		if(last_obj.objNext != null) {
			spr.objNext = last_obj.objNext;
			last_obj.objNext.objPrev = spr;
		}else {
			spr.objNext = null;
		}
		last_obj.objNext = spr;
		spr.objPrev = last_obj;
	}
	public CSprite GetFirstSprite_EX(int nLayer, int dwFlags ) {
		if( cash_spr_lay[nLayer] != null ) return cash_spr_lay[nLayer];
		CSprite f = ho.hoAdRunHeader.spriteGen.getFirstSprite(-1, 0);
		while (f != null) {
			if (f.sprLayer == nLayer || f.sprLayer > nLayer) {
				break;
			}
			f = f.objNext;
			cash_spr_lay[nLayer] = f;
		}
		return f;
	}

}